## sliver 1.5.42

=== Makefile ===
#
# Makefile for Sliver
#

GO ?= go
ARTIFACT_SUFFIX ?= 
ENV =
TAGS ?= -tags osusergo,netgo,cgosqlite,sqlite_omit_load_extension


#
# Prerequisites 
#
# https://stackoverflow.com/questions/5618615/check-if-a-program-exists-from-a-makefile
EXECUTABLES = uname sed git zip date cut $(GO)
K := $(foreach exec,$(EXECUTABLES),\
        $(if $(shell which $(exec)),some string,$(error "No $(exec) in PATH")))

#
# Version Information
#
GO_VERSION = $(shell $(GO) version)
GO_MAJOR_VERSION = $(shell $(GO) version | cut -c 14- | cut -d' ' -f1 | cut -d'.' -f1)
GO_MINOR_VERSION = $(shell $(GO) version | cut -c 14- | cut -d' ' -f1 | cut -d'.' -f2)
MIN_SUPPORTED_GO_MAJOR_VERSION = 1
MIN_SUPPORTED_GO_MINOR_VERSION = 18
GO_VERSION_VALIDATION_ERR_MSG = Golang version is not supported, please update to at least $(MIN_SUPPORTED_GO_MAJOR_VERSION).$(MIN_SUPPORTED_GO_MINOR_VERSION)

VERSION ?= $(shell git describe --abbrev=0)
COMPILED_AT = $(shell date +%s)
RELEASES_URL ?= https://api.github.com/repos/BishopFox/sliver/releases
ARMORY_PUB_KEY ?= RWSBpxpRWDrD7Fe+VvRE3c2VEDC2NK80rlNCj+BX0gz44Xw07r6KQD9L
ARMORY_REPO_URL ?= https://api.github.com/repos/sliverarmory/armory/releases
VERSION_PKG = github.com/bishopfox/sliver/client/version
CLIENT_ASSETS_PKG = github.com/bishopfox/sliver/client/assets

GIT_DIRTY = $(shell git diff --quiet|| echo 'Dirty')
GIT_COMMIT = $(shell git rev-parse HEAD)

LDFLAGS = -ldflags "-s -w \
	-X $(VERSION_PKG).Version=$(VERSION) \
	-X \"$(VERSION_PKG).GoVersion=$(GO_VERSION)\" \
	-X $(VERSION_PKG).CompiledAt=$(COMPILED_AT) \
	-X $(VERSION_PKG).GithubReleasesURL=$(RELEASES_URL) \
	-X $(VERSION_PKG).GitCommit=$(GIT_COMMIT) \
	-X $(VERSION_PKG).GitDirty=$(GIT_DIRTY) \
	-X $(CLIENT_ASSETS_PKG).DefaultArmoryPublicKey=$(ARMORY_PUB_KEY) \
	-X $(CLIENT_ASSETS_PKG).DefaultArmoryRepoURL=$(ARMORY_REPO_URL)"

# Debug builds can't be stripped (-s -w flags)
LDFLAGS_DEBUG = -ldflags "-X $(VERSION_PKG).Version=$(VERSION) \
	-X \"$(VERSION_PKG).GoVersion=$(GO_VERSION)\" \
	-X $(VERSION_PKG).CompiledAt=$(COMPILED_AT) \
	-X $(VERSION_PKG).GithubReleasesURL=$(RELEASES_URL) \
	-X $(VERSION_PKG).GitCommit=$(GIT_COMMIT) \
	-X $(VERSION_PKG).GitDirty=$(GIT_DIRTY) \
	-X $(CLIENT_ASSETS_PKG).DefaultArmoryPublicKey=$(ARMORY_PUB_KEY) \
	-X $(CLIENT_ASSETS_PKG).DefaultArmoryRepoURL=$(ARMORY_REPO_URL)"

SED_INPLACE := sed -i
STATIC_TARGET := linux

UNAME_S := $(shell uname -s)
UNAME_P := $(shell uname -p)

# If the target is Windows from Linux/Darwin, check for mingw
CROSS_COMPILERS = x86_64-w64-mingw32-gcc x86_64-w64-mingw32-g++
ifneq (,$(findstring cgosqlite,$(TAGS)))
	ENV +=CGO_ENABLED=1
	ifeq ($(MAKECMDGOALS), windows)
		K := $(foreach exec,$(CROSS_COMPILERS),\
				$(if $(shell which $(exec)),some string,$(error "Missing cross-compiler $(exec) in PATH")))
		ENV += CC=x86_64-w64-mingw32-gcc CXX=x86_64-w64-mingw32-g++
	endif
endif

# Programs required for generating protobuf/grpc files
PB_COMPILERS = protoc protoc-gen-go protoc-gen-go-grpc
ifeq ($(MAKECMDGOALS), pb)
	K := $(foreach exec,$(PB_COMPILERS),\
			$(if $(shell which $(exec)),some string,$(error "Missing protobuf util $(exec) in PATH")))
endif

# *** Darwin ***
ifeq ($(UNAME_S),Darwin)
	SED_INPLACE := sed -i ''
	STATIC_TARGET := macos
endif

# If no target is specified, determine GOARCH
ifeq ($(UNAME_P),arm)
	ifeq ($(MAKECMDGOALS), )
		ENV += GOARCH=arm64
	endif
endif

ifeq ($(MAKECMDGOALS), linux)
	# Redefine LDFLAGS to add the static part
	LDFLAGS = -ldflags "-s -w \
		-extldflags '-static' \
		-X $(VERSION_PKG).Version=$(VERSION) \
		-X \"$(VERSION_PKG).GoVersion=$(GO_VERSION)\" \
		-X $(VERSION_PKG).CompiledAt=$(COMPILED_AT) \
		-X $(VERSION_PKG).GithubReleasesURL=$(RELEASES_URL) \
		-X $(VERSION_PKG).GitCommit=$(GIT_COMMIT) \
		-X $(VERSION_PKG).GitDirty=$(GIT_DIRTY) \
		-X $(CLIENT_ASSETS_PKG).DefaultArmoryPublicKey=$(ARMORY_PUB_KEY) \
		-X $(CLIENT_ASSETS_PKG).DefaultArmoryRepoURL=$(ARMORY_REPO_URL)"
endif

ifeq ($(MAKECMDGOALS), linux-arm64)
	# Redefine TAGS/ENV to use pure go sqlite3
	TAGS = -tags osusergo,netgo,gosqlite
	ENV = CGO_ENABLED=0
endif

#
# Targets
#
.PHONY: default
default: clean .downloaded_assets validate-go-version
	$(ENV) $(GO) build -mod=vendor -trimpath $(TAGS),server $(LDFLAGS) -o sliver-server$(ARTIFACT_SUFFIX) ./server
	$(ENV) $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client$(ARTIFACT_SUFFIX) ./client

.PHONY: macos
macos: clean .downloaded_assets validate-go-version
	GOOS=darwin GOARCH=amd64 $(ENV) $(GO) build -mod=vendor -trimpath $(TAGS),server $(LDFLAGS) -o sliver-server$(ARTIFACT_SUFFIX) ./server
	GOOS=darwin GOARCH=amd64 $(ENV) $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client$(ARTIFACT_SUFFIX) ./client

.PHONY: macos-arm64
macos-arm64: clean .downloaded_assets validate-go-version
	GOOS=darwin GOARCH=arm64 $(ENV) $(GO) build -mod=vendor -trimpath $(TAGS),server $(LDFLAGS) -o sliver-server$(ARTIFACT_SUFFIX) ./server
	GOOS=darwin GOARCH=arm64 $(ENV) $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client$(ARTIFACT_SUFFIX) ./client

.PHONY: linux
linux: clean .downloaded_assets validate-go-version
	GOOS=linux GOARCH=amd64 $(ENV) $(GO) build -mod=vendor -trimpath $(TAGS),server $(LDFLAGS) -o sliver-server$(ARTIFACT_SUFFIX) ./server
	GOOS=linux GOARCH=amd64 $(ENV) $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client$(ARTIFACT_SUFFIX) ./client

.PHONY: linux-arm64
linux-arm64: clean .downloaded_assets validate-go-version
	GOOS=linux GOARCH=arm64 $(ENV) $(GO) build -mod=vendor -trimpath $(TAGS),server $(LDFLAGS) -o sliver-server$(ARTIFACT_SUFFIX) ./server
	GOOS=linux GOARCH=arm64 $(ENV) $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client$(ARTIFACT_SUFFIX) ./client

.PHONY: windows
windows: clean .downloaded_assets validate-go-version
	GOOS=windows $(ENV) $(GO) build -mod=vendor -trimpath $(TAGS),server $(LDFLAGS) -o sliver-server$(ARTIFACT_SUFFIX).exe ./server
	GOOS=windows $(ENV) $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client$(ARTIFACT_SUFFIX).exe ./client

.PHONY: pb
pb:
	protoc -I protobuf/ protobuf/commonpb/common.proto --go_out=paths=source_relative:protobuf/
	protoc -I protobuf/ protobuf/sliverpb/sliver.proto --go_out=paths=source_relative:protobuf/
	protoc -I protobuf/ protobuf/clientpb/client.proto --go_out=paths=source_relative:protobuf/
	protoc -I protobuf/ protobuf/dnspb/dns.proto --go_out=paths=source_relative:protobuf/
	protoc -I protobuf/ protobuf/rpcpb/services.proto --go_out=paths=source_relative:protobuf/ --go-grpc_out=protobuf/ --go-grpc_opt=paths=source_relative 

.PHONY: debug
debug: clean
	$(ENV) $(GO) build -mod=vendor $(TAGS),server $(LDFLAGS_DEBUG) -o sliver-server$(ARTIFACT_SUFFIX) ./server
	$(ENV) $(GO) build -mod=vendor $(TAGS),client $(LDFLAGS_DEBUG) -o sliver-client$(ARTIFACT_SUFFIX) ./client

validate-go-version:
	@if [ $(GO_MAJOR_VERSION) -gt $(MIN_SUPPORTED_GO_MAJOR_VERSION) ]; then \
		exit 0 ;\
	elif [ $(GO_MAJOR_VERSION) -lt $(MIN_SUPPORTED_GO_MAJOR_VERSION) ]; then \
		echo '$(GO_VERSION_VALIDATION_ERR_MSG)';\
		exit 1; \
	elif [ $(GO_MINOR_VERSION) -lt $(MIN_SUPPORTED_GO_MINOR_VERSION) ] ; then \
		echo '$(GO_VERSION_VALIDATION_ERR_MSG)';\
		exit 1; \
	fi

.PHONY: clean-all
clean-all: clean
	rm -rf ./server/assets/fs/darwin/amd64
	rm -rf ./server/assets/fs/darwin/arm64
	rm -rf ./server/assets/fs/windows/amd64
	rm -rf ./server/assets/fs/linux/amd64
	rm -f ./server/assets/fs/*.zip
	rm -f ./.downloaded_assets

.PHONY: clean
clean:
	rm -f sliver-client sliver-server sliver-*.exe

.downloaded_assets:
	./go-assets.sh
	touch ./.downloaded_assets

## sliver 1.5.41

=== debian/changelog ===
sliver (1.5.41-0parrot1) lory; urgency=medium

  * Rebuild for Parrot 6.0.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Fri, 08 Sep 2023 17:12:08 +0200

sliver (1.5.41-0kali2) kali-dev; urgency=medium

  * Add patch to fix FTBFS with Go 1.21
  * Disable network access for the Go compiler
  * Drop Build-Depends dh-golang
  * Adjust auto_install target

 -- Arnaud Rebillout <arnaudr@kali.org>  Tue, 29 Aug 2023 16:09:48 +0700

sliver (1.5.41-0kali1) kali-dev; urgency=medium

  * New upstream version 1.5.41

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Mon, 28 Aug 2023 11:37:51 +0200

sliver (1.5.37-0kali2) kali-dev; urgency=medium

  * Generate shell autocompletion scripts

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Tue, 25 Apr 2023 11:31:28 +0200

sliver (1.5.37-0kali1) kali-dev; urgency=medium

  [ Steev Klimaszewski ]
  * ci: Disable 32bit builds.

  [ Daniel Ruiz de Alegría ]
  * New upstream version 1.5.37

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Sun, 23 Apr 2023 11:43:43 +0200

sliver (1.5.34-0kali1) kali-dev; urgency=medium

  * New upstream version 1.5.34
  * Update package

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Tue, 21 Feb 2023 12:30:45 +0100

sliver (1.5.31-0kali1) kali-dev; urgency=medium

  * New upstream version 1.5.31

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Fri, 04 Nov 2022 09:11:23 +0100

sliver (1.5.30-0kali1) kali-dev; urgency=medium

  * New upstream version 1.5.30

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Wed, 19 Oct 2022 08:52:50 +0200

sliver (1.5.29-0kali1) kali-dev; urgency=medium

  * New upstream version 1.5.29
  * Update packaging
  * Update patches

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Mon, 10 Oct 2022 12:20:39 +0200

sliver (1.5.24-0kali1) kali-dev; urgency=medium

  [ Arnaud Rebillout ]
  * Disable i386 build in Kali CI

  [ Daniel Ruiz de Alegría ]
  * New upstream version 1.5.24

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Fri, 02 Sep 2022 16:21:20 +0200

sliver (1.5.21-0kali2) kali-dev; urgency=medium

  * Drop Build-Depends golang-github-gobuffalo-packr-dev

 -- Arnaud Rebillout <arnaudr@kali.org>  Sat, 13 Aug 2022 00:35:44 +0700

sliver (1.5.21-0kali1) kali-dev; urgency=medium

  * New upstream version 1.5.21

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Thu, 28 Jul 2022 17:59:32 +0200

sliver (1.5.20-0kali1) kali-dev; urgency=medium

  * New upstream version 1.5.20

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Mon, 25 Jul 2022 21:15:21 +0200

sliver (1.5.19-0kali1) kali-dev; urgency=medium

  * New upstream version 1.5.19

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Tue, 19 Jul 2022 12:39:08 +0200

sliver (1.5.17-0kali1) kali-dev; urgency=medium

  * New upstream version 1.5.17

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Fri, 01 Jul 2022 11:56:32 +0200

sliver (1.5.16-0kali1) kali-dev; urgency=medium

  * New upstream version 1.5.16
  * wrap-and-sort -ast
  * Remove old 'arch 32' patch

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Fri, 10 Jun 2022 17:07:16 +0200

sliver (1.5.14-0kali2) kali-dev; urgency=medium

  * Change architecture from 'any' to 64bit only
  * Remove unneded export in debian/rules
  * Remove comma in architectures
  * Fix debian/test

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Mon, 06 Jun 2022 15:08:34 +0200

sliver (1.5.14-0kali1) kali-dev; urgency=medium

  [ Ben Wilson ]
  * Remove template comment and switch spaces to tabs

  [ Daniel Ruiz de Alegría ]
  * New upstream version 1.5.14
  * Update package
  * Override lintian warning no-manual-page for sliver-client
  * Fix VERSION variable
  * Add basic test for sliver-client

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Fri, 03 Jun 2022 22:16:42 +0200

sliver (1.1.1-0kali3) kali-dev; urgency=medium

  * Add superficial autopkgtest

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 12 Jul 2021 14:12:22 +0200

sliver (1.1.1-0kali2) kali-dev; urgency=medium

  * Update dependencies
  * Add a patch to fix build for 32 bit

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 12 Jul 2021 14:12:19 +0200

sliver (1.1.1-0kali1) kali-dev; urgency=medium

  [ Kali Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

  [ Raphaël Hertzog ]
  * Fix watch file

  [ Sophie Brun ]
  * New upstream version 1.1.1
  * Bump Standards-Version to 4.5.1
  * Refresh patches

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 02 Jul 2021 16:19:06 +0200

sliver (0.0.6~alpha+git20200416-0kali2) kali-dev; urgency=medium

  * Add metasploit-framework and mingw* in Recommends

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 19 May 2020 11:33:50 +0200

sliver (0.0.6~alpha+git20200416-0kali1) kali-dev; urgency=medium

  * Initial release (see 6146)

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 16 Apr 2020 17:25:35 +0200

=== debian/control ===
Source: sliver
Section: net
Priority: optional
Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Build-Depends:
 ca-certificates,
 curl,
 debhelper-compat (= 13),
 golang-go,
 golang-goprotobuf-dev,
 protobuf-compiler,
 unzip,
 zip,
Standards-Version: 4.6.2
Homepage: https://github.com/BishopFox/sliver

Package: sliver
Architecture: amd64 arm64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 binutils-mingw-w64,
 build-essential,
 g++-mingw-w64,
 metasploit-framework,
 mingw-w64,
Built-Using:
 ${misc:Built-Using},
Description: Implant framework
 This package contains a general purpose cross-platform implant framework that
 supports C2 over Mutual-TLS, HTTP(S), and DNS. Implants are dynamically
 compiled with unique X.509 certificates signed by a per-instance certificate
 authority generated when you first run the binary.

## sliver 1.5.42

=== debian/changelog ===
sliver (1.5.42-0kali1) kali-dev; urgency=medium

  [ Arnaud Rebillout ]
  * Consolidate patches related to gvisor update

  [ Daniel Ruiz de Alegría ]
  * New upstream version 1.5.42
  * Refresh patches

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Thu, 29 Feb 2024 16:56:40 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: sliver
 Section: net
 Priority: optional
-Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
-Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
+Maintainer: Kali Developers <devel@kali.org>
+Uploaders:
+ Sophie Brun <sophie@offensive-security.com>,
 Build-Depends:
  ca-certificates,
  curl,
@@ -14,6 +15,8 @@
  zip,
 Standards-Version: 4.6.2
 Homepage: https://github.com/BishopFox/sliver
+Vcs-Browser: https://gitlab.com/kalilinux/packages/sliver
+Vcs-Git: https://gitlab.com/kalilinux/packages/sliver.git
 
 Package: sliver
 Architecture: amd64 arm64

=== debian/rules ===
#!/usr/bin/make -f

# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

export GOCACHE=$(CURDIR)/vendor
export GOPATH=$(CURDIR)/vendor
export GO111MODULE=on
export GOPROXY=off
export GOTOOLCHAIN=local

# Needed to run sliver binaries to create shell autocompletions
export SLIVER_ROOT_DIR=/tmp

%:
	dh $@

override_dh_auto_build:
	VERSION=$(DEB_VERSION_UPSTREAM) make

# Ideally we'd run the test suite, however there are two issues:
# 1. warning that it might take a LONG time -- if that's true that it really
#    takes too long, maybe patching go-tests.sh to add the '-short' argument
#    to 'go test' is enough.
# 2. multiple failures anyway -- needs some time to dive in and fix it all. 
#override_dh_auto_test:
#	./go-tests.sh

execute_after_dh_auto_install:
	# install bash/zsh completion
	mkdir -p debian/sliver/usr/share/bash-completion/completions debian/sliver/usr/share/zsh/vendor-completions/
	./sliver-server completion bash > debian/sliver/usr/share/bash-completion/completions/sliver-server
	./sliver-client completion bash > debian/sliver/usr/share/bash-completion/completions/sliver-client
	./sliver-server completion zsh > debian/sliver/usr/share/zsh/vendor-completions/_sliver-server
	./sliver-client completion zsh > debian/sliver/usr/share/zsh/vendor-completions/_sliver-client

=== debian/tests/control ===
Test-Command: sliver-server -h
Restrictions: superficial

Test-Command: sliver-client -h
Restrictions: superficial

=== debian/watch ===
version=4
opts="uversionmangle=s/-(alpha|beta)/~$1/, \
      filenamemangle=s%(?:.*?)?v?(\d.*).tar\.gz%sliver-$1.tar.gz%" \
   https://github.com/BishopFox/sliver/tags \
   (?:.*?/)?v?(\d.*)\.tar\.gz

## sliver 1.5.43

=== debian/changelog ===
sliver (1.5.43-0parrot3) lory-updates; urgency=medium

  * Only recommends the proper mingw packages.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Tue, 01 Jul 2025 08:33:55 +0200

sliver (1.5.43-0parrot2) lory-updates; urgency=medium

  * Use "parrot" as version.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Mon, 30 Jun 2025 14:55:50 +0200

sliver (1.5.43-0parrot1) lory; urgency=medium

  * Import new upstream release.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Mon, 30 Jun 2025 09:47:45 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: sliver
 Section: net
 Priority: optional
-Maintainer: Kali Developers <devel@kali.org>
-Uploaders:
- Sophie Brun <sophie@offensive-security.com>,
+Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
+Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
 Build-Depends:
  ca-certificates,
  curl,
@@ -15,8 +14,6 @@
  zip,
 Standards-Version: 4.6.2
 Homepage: https://github.com/BishopFox/sliver
-Vcs-Browser: https://gitlab.com/kalilinux/packages/sliver
-Vcs-Git: https://gitlab.com/kalilinux/packages/sliver.git
 
 Package: sliver
 Architecture: amd64 arm64
@@ -24,11 +21,10 @@
  ${misc:Depends},
  ${shlibs:Depends},
 Recommends:
- binutils-mingw-w64,
  build-essential,
- g++-mingw-w64,
+ gcc-mingw-w64-x86-64-posix,
+ g++-mingw-w64-x86-64-posix,
  metasploit-framework,
- mingw-w64,
 Built-Using:
  ${misc:Built-Using},
 Description: Implant framework

## sliver 1.7.1

=== Makefile ===
#
# Makefile for Sliver
#

GO ?= go
ARTIFACT_SUFFIX ?= 
ENV =
TAGS ?= -tags go_sqlite
CGO_ENABLED = 0

ifneq (,$(findstring cgo_sqlite,$(TAGS)))
	CGO_ENABLED = 1
endif

#
# Prerequisites 
#
# https://stackoverflow.com/questions/5618615/check-if-a-program-exists-from-a-makefile
EXECUTABLES = uname sed git date cut $(GO)
K := $(foreach exec,$(EXECUTABLES),\
        $(if $(shell which $(exec)),some string,$(error "No $(exec) in PATH")))

#
# Build Information
#
GO_MAJOR_VERSION = $(shell $(GO) version | cut -c 14- | cut -d' ' -f1 | cut -d'.' -f1)
GO_MINOR_VERSION = $(shell $(GO) version | cut -c 14- | cut -d' ' -f1 | cut -d'.' -f2)
MIN_SUPPORTED_GO_MAJOR_VERSION = 1
MIN_SUPPORTED_GO_MINOR_VERSION = 24
GO_VERSION_VALIDATION_ERR_MSG = Golang version is not supported, please update to at least $(MIN_SUPPORTED_GO_MAJOR_VERSION).$(MIN_SUPPORTED_GO_MINOR_VERSION)

SLIVER_PUBLIC_KEY ?= RWTZPg959v3b7tLG7VzKHRB1/QT+d3c71Uzetfa44qAoX5rH7mGoQTTR
ARMORY_PUBLIC_KEY ?= RWSBpxpRWDrD7Fe+VvRE3c2VEDC2NK80rlNCj+BX0gz44Xw07r6KQD9L
ARMORY_REPO_URL ?= https://api.github.com/repos/sliverarmory/armory/releases
CLIENT_ASSETS_PKG = github.com/bishopfox/sliver/client/assets
SLIVER_UPDATE_PKG = github.com/bishopfox/sliver/client/command/update

LDFLAGS = -ldflags "-s -w \
	-X $(SLIVER_UPDATE_PKG).SliverPublicKey=$(SLIVER_PUBLIC_KEY) \
	-X $(CLIENT_ASSETS_PKG).DefaultArmoryPublicKey=$(ARMORY_PUBLIC_KEY) \
	-X $(CLIENT_ASSETS_PKG).DefaultArmoryRepoURL=$(ARMORY_REPO_URL)"

# Debug builds shouldn't be stripped (-s -w flags)
LDFLAGS_DEBUG = -ldflags "-X $(CLIENT_ASSETS_PKG).DefaultArmoryPublicKey=$(ARMORY_PUBLIC_KEY) \
	-X $(CLIENT_ASSETS_PKG).DefaultArmoryRepoURL=$(ARMORY_REPO_URL)"

SED_INPLACE := sed -i
STATIC_TARGET := linux

UNAME_S := $(shell uname -s)
UNAME_P := $(shell uname -p)

# Programs required for generating protobuf/grpc files
PB_COMPILERS = protoc protoc-gen-go protoc-gen-go-grpc
ifeq ($(MAKECMDGOALS), pb)
	K := $(foreach exec,$(PB_COMPILERS),\
			$(if $(shell which $(exec)),some string,$(error "Missing protobuf util $(exec) in PATH")))
endif

# *** Darwin ***
ifeq ($(UNAME_S),Darwin)
	SED_INPLACE := sed -i ''
	STATIC_TARGET := macos
endif

# If no target is specified, determine GOARCH
ifeq ($(UNAME_P),arm)
	ifeq ($(MAKECMDGOALS), )
		ifeq ($(origin GOARCH), undefined)
			ENV += GOARCH=arm64
		endif
	endif
endif

ifeq ($(MAKECMDGOALS), linux)
	# Redefine LDFLAGS to add the static part
	LDFLAGS = -ldflags "-s -w \
		-extldflags '-static' \
		-X $(CLIENT_ASSETS_PKG).DefaultArmoryPublicKey=$(ARMORY_PUBLIC_KEY) \
		-X $(CLIENT_ASSETS_PKG).DefaultArmoryRepoURL=$(ARMORY_REPO_URL)"
endif

#
# Targets
#
.PHONY: default
default: clean validate-go-version
	env -u GOOS -u GOARCH $(MAKE) GOOS= GOARCH= .downloaded_assets
	$(ENV) $(if $(GOOS),GOOS=$(GOOS)) $(if $(GOARCH),GOARCH=$(GOARCH)) CGO_ENABLED=$(CGO_ENABLED) $(GO) build -mod=vendor -trimpath $(TAGS),server $(LDFLAGS) -o sliver-server$(ARTIFACT_SUFFIX) ./server
	$(ENV) $(if $(GOOS),GOOS=$(GOOS)) $(if $(GOARCH),GOARCH=$(GOARCH)) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client$(ARTIFACT_SUFFIX) ./client

# Allows you to build a CGO-free client for any target e.g. `GOOS=windows GOARCH=arm64 make client`
# NOTE: WireGuard is not supported on all platforms, but most 64-bit GOOS/GOARCH combinations should work.
.PHONY: client
client: clean .downloaded_assets validate-go-version
	$(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client ./client

.PHONY: macos-amd64
macos-amd64: clean .downloaded_assets validate-go-version
	GOOS=darwin GOARCH=amd64 $(ENV) CGO_ENABLED=$(CGO_ENABLED) $(GO) build -mod=vendor -trimpath $(TAGS),server $(LDFLAGS) -o sliver-server$(ARTIFACT_SUFFIX) ./server
	GOOS=darwin GOARCH=amd64 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client$(ARTIFACT_SUFFIX) ./client

.PHONY: macos-arm64
macos-arm64: clean .downloaded_assets validate-go-version
	GOOS=darwin GOARCH=arm64 $(ENV) CGO_ENABLED=$(CGO_ENABLED) $(GO) build -mod=vendor -trimpath $(TAGS),server $(LDFLAGS) -o sliver-server$(ARTIFACT_SUFFIX) ./server
	GOOS=darwin GOARCH=arm64 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client$(ARTIFACT_SUFFIX) ./client

.PHONY: linux-amd64
linux-amd64: clean .downloaded_assets validate-go-version
	GOOS=linux GOARCH=amd64 $(ENV) CGO_ENABLED=$(CGO_ENABLED) $(GO) build -mod=vendor -trimpath $(TAGS),server $(LDFLAGS) -o sliver-server$(ARTIFACT_SUFFIX) ./server
	GOOS=linux GOARCH=amd64 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client$(ARTIFACT_SUFFIX) ./client

.PHONY: linux-arm64
linux-arm64: clean .downloaded_assets validate-go-version
	GOOS=linux GOARCH=arm64 $(ENV) CGO_ENABLED=$(CGO_ENABLED) $(GO) build -mod=vendor -trimpath $(TAGS),server $(LDFLAGS) -o sliver-server$(ARTIFACT_SUFFIX) ./server
	GOOS=linux GOARCH=arm64 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client$(ARTIFACT_SUFFIX) ./client

.PHONY: windows-amd64
windows-amd64: clean .downloaded_assets validate-go-version
	GOOS=windows GOARCH=amd64 $(ENV) CGO_ENABLED=$(CGO_ENABLED) $(GO) build -mod=vendor -trimpath $(TAGS),server $(LDFLAGS) -o sliver-server$(ARTIFACT_SUFFIX).exe ./server
	GOOS=windows GOARCH=amd64 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client$(ARTIFACT_SUFFIX).exe ./client

.PHONY: clients
clients: clean .downloaded_assets validate-go-version
	GOOS=darwin GOARCH=amd64 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client_macos-amd64$(ARTIFACT_SUFFIX) ./client
	GOOS=darwin GOARCH=arm64 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client_macos-arm64$(ARTIFACT_SUFFIX) ./client
	GOOS=linux GOARCH=386 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client_linux-386$(ARTIFACT_SUFFIX) ./client
	GOOS=linux GOARCH=amd64 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client_linux-amd64$(ARTIFACT_SUFFIX) ./client
	GOOS=linux GOARCH=arm64 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client_linux-arm64$(ARTIFACT_SUFFIX) ./client
	GOOS=windows GOARCH=386 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client_windows-386$(ARTIFACT_SUFFIX).exe ./client
	GOOS=windows GOARCH=amd64 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client_windows-amd64$(ARTIFACT_SUFFIX).exe ./client
	GOOS=windows GOARCH=arm64 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client_windows-arm64$(ARTIFACT_SUFFIX).exe ./client
	GOOS=freebsd GOARCH=amd64 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client_freebsd-amd64$(ARTIFACT_SUFFIX) ./client
	GOOS=freebsd GOARCH=arm64 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),client $(LDFLAGS) -o sliver-client_freebsd-arm64$(ARTIFACT_SUFFIX) ./client

.PHONY: servers
servers: clean .downloaded_assets validate-go-version
	GOOS=windows GOARCH=amd64 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),server $(LDFLAGS) -o sliver-server_windows-amd64$(ARTIFACT_SUFFIX).exe ./server
	GOOS=windows GOARCH=arm64 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),server $(LDFLAGS) -o sliver-server_windows-arm64$(ARTIFACT_SUFFIX).exe ./server
	GOOS=linux GOARCH=amd64 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),server $(LDFLAGS) -o sliver-server_linux-amd64$(ARTIFACT_SUFFIX) ./server
	GOOS=linux GOARCH=arm64 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),server $(LDFLAGS) -o sliver-server_linux-arm64$(ARTIFACT_SUFFIX) ./server
	GOOS=darwin GOARCH=arm64 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),server $(LDFLAGS) -o sliver-server_darwin-arm64$(ARTIFACT_SUFFIX) ./server
	GOOS=darwin GOARCH=amd64 $(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor -trimpath $(TAGS),server $(LDFLAGS) -o sliver-server_darwin-amd64$(ARTIFACT_SUFFIX) ./server

.PHONY: pb
pb:
	protoc -I protobuf/ protobuf/commonpb/common.proto --go_out=paths=source_relative:protobuf/
	protoc -I protobuf/ protobuf/sliverpb/sliver.proto --go_out=paths=source_relative:protobuf/
	protoc -I protobuf/ protobuf/clientpb/client.proto --go_out=paths=source_relative:protobuf/
	protoc -I protobuf/ protobuf/dnspb/dns.proto --go_out=paths=source_relative:protobuf/
	protoc -I protobuf/ protobuf/rpcpb/services.proto --go_out=paths=source_relative:protobuf/ --go-grpc_out=protobuf/ --go-grpc_opt=paths=source_relative 

.PHONY: debug
debug: clean
	$(ENV) CGO_ENABLED=$(CGO_ENABLED) $(GO) build -mod=vendor $(TAGS),server $(LDFLAGS_DEBUG) -o sliver-server$(ARTIFACT_SUFFIX) ./server
	$(ENV) CGO_ENABLED=0 $(GO) build -mod=vendor $(TAGS),client $(LDFLAGS_DEBUG) -o sliver-client$(ARTIFACT_SUFFIX) ./client

validate-go-version:
	@if [ $(GO_MAJOR_VERSION) -gt $(MIN_SUPPORTED_GO_MAJOR_VERSION) ]; then \
		exit 0 ;\
	elif [ $(GO_MAJOR_VERSION) -lt $(MIN_SUPPORTED_GO_MAJOR_VERSION) ]; then \
		echo '$(GO_VERSION_VALIDATION_ERR_MSG)';\
		exit 1; \
	elif [ $(GO_MINOR_VERSION) -lt $(MIN_SUPPORTED_GO_MINOR_VERSION) ] ; then \
		echo '$(GO_VERSION_VALIDATION_ERR_MSG)';\
		exit 1; \
	fi

.PHONY: clean-all
clean-all: clean
	rm -rf ./server/assets/fs/darwin/amd64
	rm -rf ./server/assets/fs/darwin/arm64
	rm -rf ./server/assets/fs/windows/amd64
	rm -rf ./server/assets/fs/linux/amd64
	rm -f ./server/assets/fs/*.zip
	rm -f ./.downloaded_assets

.PHONY: clean
clean:
	rm -f sliver-client sliver-client_* sliver-server sliver-server_* sliver-*.exe

.downloaded_assets:
	$(ENV) $(GO) run -mod=vendor ./util/cmd/assets
	touch ./.downloaded_assets

=== server/assets/traffic-encoders/Makefile ===
#
# You will need TinyGo and Rust installed to compile the WASM modules.
#
# After installing Rust `rustup target add wasm32-unknown-unknown`
#

CARGO ?= cargo
EXECUTABLES = $(CARGO)
K := $(foreach exec,$(EXECUTABLES),\
        $(if $(shell which $(exec)),some string,$(error "No $(exec) in PATH")))

all: hex.wasm

hex.wasm:
	cd hex && $(CARGO) build --release --target wasm32-unknown-unknown && cp target/wasm32-unknown-unknown/release/hex.wasm ../hex.wasm

clean:
	rm -f hex.wasm

=== vendor/github.com/PagerDuty/go-pagerduty/Makefile ===
# SOURCEDIR=.
# SOURCES = $(shell find $(SOURCEDIR) -name '*.go')
# VERSION=$(git describe --always --tags)
# BINARY=bin/pd

# bin: $(BINARY)

# $(BINARY): $(SOURCES)
# 	go build -o $(BINARY) command/*

.PHONY: build
build: build-deps
	go build -mod=vendor -o pd ./command

.PHONY: build-deps
build-deps:
	go get
	go mod verify
	go mod vendor

.PHONY: install
install: build
	cp pd $(GOROOT)/bin

.PHONY: test
test:
	go test -v ./...

.PHONY: deploy
deploy:
	- curl -sL https://git.io/goreleaser | bash

=== vendor/github.com/appleboy/go-fcm/Makefile ===
GO ?= go

.PHONY: test
test:
	@$(GO) test -v -cover -coverprofile coverage.out ./... && echo "\n==>\033[32m Ok\033[m\n" || exit 1

clean:
	go clean -x -i ./...

=== vendor/github.com/kevinburke/go-types/Makefile ===
.PHONY: install test
BUMP_VERSION := $(GOPATH)/bin/bump_version
GODOCDOC := $(GOPATH)/bin/godocdoc
STATICCHECK := $(GOPATH)/bin/staticcheck

test: lint
	go test ./...

install:
	go get ./...
	go install ./...

lint:
	go run honnef.co/go/tools/cmd/staticcheck@latest ./...
	go vet ./...

race-test: lint
	go test -race ./...

$(BUMP_VERSION):
	go get github.com/kevinburke/bump_version

release: test | $(BUMP_VERSION)
	$(BUMP_VERSION) minor types.go

docs: | $(GODOCDOC)
	$(GODOCDOC)

=== vendor/github.com/kevinburke/twilio-go/Makefile ===
.PHONY: test vet release

# would be great to make the bash location portable but not sure how
SHELL = /bin/bash -o pipefail

test: lint
	go test ./...

lint: fmt
	go vet ./...
	go run honnef.co/go/tools/cmd/staticcheck@latest ./...

race-test: lint
	go test -race ./...

race-test-short: lint
	go test -short -race ./...

fmt:
	go fmt ./...

ci: | $(DIFFER)
	# would love to run differ make authors here, but Github doesn't check out
	# the full history
	go run -v github.com/kevinburke/differ@latest $(MAKE) fmt
	$(MAKE) lint race-test-short

release: race-test-short
	go run -v github.com/kevinburke/differ@latest $(MAKE) authors
	go run -v github.com/kevinburke/differ@latest $(MAKE) fmt
	go run -v github.com/kevinburke/bump_version@latest --tag-prefix=v minor http.go

force: ;

AUTHORS.txt: .mailmap force
	go run -v github.com/kevinburke/write_mailmap@latest > AUTHORS.txt

authors: AUTHORS.txt

=== vendor/github.com/mailgun/errors/Makefile ===
GOLANGCI_LINT = $(GOPATH)/bin/golangci-lint
GOLANGCI_LINT_VERSION = v1.57.2

.PHONY: lint
lint: $(GOLANGCI_LINT)
	$(GOLANGCI_LINT) run

$(GOLANGCI_LINT):
	curl -sfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $(GOPATH)/bin $(GOLANGCI_LINT_VERSION)

.PHONY: test
test:
	go test -p 1 ./... -short -race -timeout 1m -count=1

=== vendor/github.com/moloch--/go-keystone/Makefile ===
SHELL := /bin/bash

DIST_DIR ?= dist
GO_BIN_NAME := go-keystone
WASM_BIN_NAME := keystone
GO_BIN ?= $(shell if [ -x /opt/homebrew/bin/go ]; then echo /opt/homebrew/bin/go; elif command -v go >/dev/null 2>&1; then command -v go; else echo go; fi)

KEYSTONE_WASM_VERSION ?= v0.0.1
KEYSTONE_WASM_URL := https://github.com/moloch--/keystone/releases/download/$(KEYSTONE_WASM_VERSION)/keystone.wasm

WASM_PUBLIC_DIR := wasm
WASM_PUBLIC_MODULE := $(WASM_PUBLIC_DIR)/$(WASM_BIN_NAME).wasm
WASM_EXPORT_DIR := $(DIST_DIR)/wasm
WASM_MODULE := $(WASM_EXPORT_DIR)/$(WASM_BIN_NAME).wasm

GO_SOURCES := $(shell find cli -type f -name '*.go') $(shell find . -maxdepth 1 -type f -name '*.go')

# Cross-compile matrix used by `make all` (overridable by setting GO_PLATFORMS).
GO_PLATFORMS ?= darwin/amd64 darwin/arm64 windows/amd64 windows/arm64 linux/amd64 linux/arm64

HOST_GOOS := $(shell $(GO_BIN) env GOOS)
HOST_GOARCH := $(shell $(GO_BIN) env GOARCH)
HOST_PLATFORM := $(HOST_GOOS)/$(HOST_GOARCH)

define GO_OUTPUT_FILENAME
$(DIST_DIR)/$(GO_BIN_NAME)_$(subst /,-,$(1))$(if $(filter windows/%,$(1)),.exe,)
endef

define GO_BUILD_RULE
$(call GO_OUTPUT_FILENAME,$(1)): $(GO_SOURCES) go.mod go.sum $(WASM_PUBLIC_MODULE) | $(DIST_DIR)
	GOOS=$(word 1,$(subst /, ,$(1))) GOARCH=$(word 2,$(subst /, ,$(1))) CGO_ENABLED=0 $(GO_BIN) build -v -trimpath -ldflags "-s -w" -o $$@ ./cli
endef

ALL_PLATFORMS := $(sort $(GO_PLATFORMS) $(HOST_PLATFORM))
$(foreach platform,$(ALL_PLATFORMS),$(eval $(call GO_BUILD_RULE,$(platform))))

HOST_OUTPUT := $(call GO_OUTPUT_FILENAME,$(HOST_PLATFORM))
GO_OUTPUTS := $(foreach platform,$(GO_PLATFORMS),$(call GO_OUTPUT_FILENAME,$(platform)))


.PHONY: all go wasm clean
.DEFAULT_GOAL := go

go: $(HOST_OUTPUT)

all: $(GO_OUTPUTS)

$(DIST_DIR):
	mkdir -p $@

$(WASM_EXPORT_DIR):
	mkdir -p $@

$(WASM_PUBLIC_MODULE):
	@set -euo pipefail; \
	tmp="$$(mktemp)"; \
	mkdir -p "$(dir $@)"; \
	if curl --fail --location --silent --show-error "$(KEYSTONE_WASM_URL)" -o "$$tmp"; then \
		mv "$$tmp" "$@"; \
	else \
		rm -f "$$tmp"; \
		exit 1; \
	fi

$(WASM_MODULE): $(WASM_PUBLIC_MODULE) | $(WASM_EXPORT_DIR)
	cp -f $< $@

wasm: $(WASM_PUBLIC_MODULE) $(WASM_MODULE)

clean:
	rm -rf $(DIST_DIR)

clean-wasm:
	rm -rf $(WASM_EXPORT_DIR)

=== vendor/github.com/nikoksr/notify/Makefile ===
export GO111MODULE := on
export GOPROXY = https://proxy.golang.org,direct

###############################################################################
# DEPENDENCIES
###############################################################################

# Install all the build and lint dependencies
tools:
	@go install mvdan.cc/gofumpt@latest
	@go install github.com/daixiang0/gci@latest
	@go install github.com/golangci/golangci-lint/cmd/golangci-lint@latest
	@go install github.com/vektra/mockery/v2@v2.44.1
	@go install github.com/segmentio/golines@latest
.PHONY: tools

###############################################################################
# TESTS
###############################################################################

test:
	@go build ./...
	@go test -failfast -race ./...
.PHONY: test

gen-coverage:
	@go test -race -covermode=atomic -coverprofile=coverage.out ./... > /dev/null
.PHONY: gen-coverage

coverage: gen-coverage
	@go tool cover -func coverage.out
.PHONY: coverage

coverage-html: gen-coverage
	@go tool cover -html=coverage.out -o cover.html
.PHONY: coverage-html

mock:
	@mockery
	@rm mock_notifier.go mock_option.go
.PHONY: mock

###############################################################################
# CODE HEALTH
###############################################################################

fmt:
	@goimports -w .
	@golines --shorten-comments -m 120 -w .
	@gofumpt -w -l .
	@gci write -s standard -s default -s "prefix(github.com/nikoksr/notify)" .
.PHONY: fmt

lint:
	@golangci-lint run ./...
.PHONY: lint

clean:
	@find . -name "mock_*" -type f -delete
.PHONY: clean

ci: lint test
.PHONY: ci

###############################################################################

.DEFAULT_GOAL := ci

=== vendor/github.com/sliverarmory/beignet/Makefile ===
GO ?= go
ZIG ?= zig

BIN ?= beignet
RUNNER_BIN ?= testdata/runner/runner

GO_CACHE_DIR ?= $(CURDIR)/.go-cache
ZIG_CACHE_DIR ?= $(CURDIR)/.zig-cache

export GOCACHE := $(GO_CACHE_DIR)
export ZIG_GLOBAL_CACHE_DIR := $(ZIG_CACHE_DIR)
export ZIG_LOCAL_CACHE_DIR := $(ZIG_CACHE_DIR)

.PHONY: all runner clean

all: $(BIN)

$(GO_CACHE_DIR):
	@mkdir -p $@

$(ZIG_CACHE_DIR):
	@mkdir -p $@

$(BIN): $(GO_CACHE_DIR)
	$(GO) build -o $@ ./cli

runner: $(RUNNER_BIN)

$(RUNNER_BIN): testdata/runner/runner.c $(ZIG_CACHE_DIR)
	$(ZIG) cc -target aarch64-macos -o $@ $<

clean:
	rm -f $(BIN) $(RUNNER_BIN)
	rm -f runner payload.bin
	rm -rf $(GO_CACHE_DIR) $(ZIG_CACHE_DIR)

=== vendor/github.com/sliverarmory/malasada/Makefile ===
GO ?= go

# The CLI does not use cgo; forcing this makes cross-compiles more reliable.
CGO_ENABLED ?= 0

EXE :=
ifeq ($(GOOS),windows)
EXE := .exe
endif

OUT ?= malasada$(EXE)

STAGE0_BINS := internal/stage0/stage0_linux_amd64.bin internal/stage0/stage0_linux_arm64.bin

.PHONY: all build test clean stage0 check-stage0

all: build

# Build the CLI for the current GOOS/GOARCH (or overridden values).
build: check-stage0
	 GOOS=$(GOOS) GOARCH=$(GOARCH) CGO_ENABLED=$(CGO_ENABLED) \
		$(GO) build -trimpath -o $(OUT) ./cli

test: check-stage0
	 $(GO) test ./...

clean:
	rm -f $(OUT)

# Force regeneration of the embedded stage0 blobs.
stage0:
	$(GO) generate ./...

check-stage0:
	@for f in $(STAGE0_BINS); do \
		if [ ! -f "$$f" ]; then \
			echo "Missing $$f"; \
			echo "Run: make stage0"; \
			exit 1; \
		fi; \
	done

=== vendor/github.com/ttacon/libphonenumber/Makefile ===
WHOAMI=$(shell whoami)

SED_I = sed -i
ifeq ($(shell uname -s), Darwin)
    SED_I = sed -i ''
endif

nothing:

generate_proto:
	docker run --rm -v $(PWD):$(PWD) -w $(PWD) znly/protoc -I. --go_out=Mgoogle/protobuf/field_mask.proto=github.com/google/go-genproto/protobuf/field_mask,plugins=grpc:./ ./google_libphonenumber/resources/*.proto
	mv ./google_libphonenumber/resources/*.pb.go ./
	sudo chown -R $(WHOAMI) *
	$(SED_I) -E 's/package i18n_phonenumbers/package libphonenumber/g' $(shell ls *.pb.go)
	awk '/static const unsigned char/ { show=1 } show; /}/ { show=0 }' ./google_libphonenumber/cpp/src/phonenumbers/metadata.cc | tail -n +2 | sed '$$d' | sed -E 's/([^,])$$/\1,/g' | awk 'BEGIN{print "package libphonenumber\nvar metaData = []byte{"}; {print}; END{print "}"}' > metagen.go
	go fmt ./metagen.go

distupdate:
	rm -rf ./google_libphonenumber
	git clone --depth 1 https://github.com/googlei18n/libphonenumber.git ./google_libphonenumber/

update: distupdate generate_proto

=== debian/changelog ===
sliver (1.7.1-0kali2) kali-dev; urgency=medium

  * Kill leaking process in tests
  * Make tests more verbose

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Thu, 12 Feb 2026 14:21:54 +0100

sliver (1.7.1-0kali1) kali-dev; urgency=medium

  [ Daniel Ruiz de Alegría ]
  * Add real tests
  * New upstream version 1.7.1
  * Refresh patches
  * Update debian/watch to version 5
  * Update Uploaders
  * Update packaging

  [ Arnaud Rebillout ]
  * Drop armel-related variable from CI (no more armel runner)

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Wed, 11 Feb 2026 11:08:06 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,10 @@
 Source: sliver
 Section: net
 Priority: optional
-Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
-Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
+Maintainer: Kali Developers <devel@kali.org>
+Uploaders:
+ Daniel Ruiz de Alegría <daniruiz@kali.org>,
+ Sophie Brun <sophie@offensive-security.com>,
 Build-Depends:
  ca-certificates,
  curl,
@@ -12,8 +14,10 @@
  protobuf-compiler,
  unzip,
  zip,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.3
 Homepage: https://github.com/BishopFox/sliver
+Vcs-Browser: https://gitlab.com/kalilinux/packages/sliver
+Vcs-Git: https://gitlab.com/kalilinux/packages/sliver.git
 
 Package: sliver
 Architecture: amd64 arm64
@@ -21,10 +25,12 @@
  ${misc:Depends},
  ${shlibs:Depends},
 Recommends:
+ binutils-mingw-w64,
  build-essential,
- gcc-mingw-w64-x86-64-posix,
- g++-mingw-w64-x86-64-posix,
+ g++-mingw-w64,
  metasploit-framework,
+ mingw-w64,
+ xsel,
 Built-Using:
  ${misc:Built-Using},
 Description: Implant framework

=== debian/rules ===
--- 
+++ 
@@ -7,26 +7,13 @@
 
 export GOCACHE=$(CURDIR)/vendor
 export GOPATH=$(CURDIR)/vendor
-export GO111MODULE=on
-export GOPROXY=off
-export GOTOOLCHAIN=local
 
 # Needed to run sliver binaries to create shell autocompletions
 export SLIVER_ROOT_DIR=/tmp
+export SLIVER_CLIENT_ROOT_DIR=/tmp
 
 %:
 	dh $@
-
-override_dh_auto_build:
-	VERSION=$(DEB_VERSION_UPSTREAM) make
-
-# Ideally we'd run the test suite, however there are two issues:
-# 1. warning that it might take a LONG time -- if that's true that it really
-#    takes too long, maybe patching go-tests.sh to add the '-short' argument
-#    to 'go test' is enough.
-# 2. multiple failures anyway -- needs some time to dive in and fix it all. 
-#override_dh_auto_test:
-#	./go-tests.sh
 
 execute_after_dh_auto_install:
 	# install bash/zsh completion

=== debian/tests/control ===
Tests: runtests.sh
Depends: procps, @
Restrictions:

=== debian/watch ===
Version: 5

Template: Github
Owner: BishopFox
Project: sliver
Uversionmangle: s/-(alpha|beta)/~$1/
